# Class VulkanViewportDimensions

java.lang.Object
com.io7m.jcoronado.api.VulkanViewportDimensions

All Implemented Interfaces:
  `VulkanViewportDimensionsType`

public final class VulkanViewportDimensions extends Object implements VulkanViewportDimensionsType
The maximum viewport dimensions in the X (width) and Y (height) dimensions, respectively.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanViewportDimensions.Builder`
  Builds instances of type `VulkanViewportDimensions`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanViewportDimensions.Builder`
  `builder()`
  Creates a builder for `VulkanViewportDimensions`.
  `static VulkanViewportDimensions`
  `copyOf(VulkanViewportDimensionsType instance)`
  Creates an immutable copy of a `VulkanViewportDimensionsType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanViewportDimensions` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `maximumX`, `maximumY`.
  `int`
  `maximumX()`
  `int`
  `maximumY()`
  `String`
  `toString()`
  Prints the immutable value `VulkanViewportDimensions` with attribute values.
  `final VulkanViewportDimensions`
  `withMaximumX(int value)`
  Copy the current immutable object by setting a value for the `maximumX` attribute.
  `final VulkanViewportDimensions`
  `withMaximumY(int value)`
  Copy the current immutable object by setting a value for the `maximumY` attribute.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### maximumX

    public int maximumX()
    Specified by:
      `maximumX` in interface `VulkanViewportDimensionsType`
    Returns:
      The maximum value in the X dimension

  - ### maximumY

    public int maximumY()
    Specified by:
      `maximumY` in interface `VulkanViewportDimensionsType`
    Returns:
      The maximum value in the Y dimension

  - ### withMaximumX

    public final VulkanViewportDimensions withMaximumX(int value)
    Copy the current immutable object by setting a value for the `maximumX` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for maximumX
    Returns:
      A modified copy or the `this` object

  - ### withMaximumY

    public final VulkanViewportDimensions withMaximumY(int value)
    Copy the current immutable object by setting a value for the `maximumY` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for maximumY
    Returns:
      A modified copy or the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanViewportDimensions` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `maximumX`, `maximumY`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanViewportDimensions` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static VulkanViewportDimensions copyOf(VulkanViewportDimensionsType instance)
    Creates an immutable copy of a `VulkanViewportDimensionsType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanViewportDimensions instance

  - ### builder

    public static VulkanViewportDimensions.Builder builder()
    Creates a builder for `VulkanViewportDimensions`.

        VulkanViewportDimensions.builder()
           .setMaximumX(int) // optional maximumX
           .setMaximumY(int) // optional maximumY
           .build();

    Returns:
      A new VulkanViewportDimensions builder